package ui.cursors
{
	import asunit.framework.TestCase;
	
	/**
	 * Пример того, как _не_ надо писать тесты.
	 * Но совсем без тестов этот CursorStack писать просто страшно
	 * (запускается на asunit 3)
	 */
	public class CursorStackTest extends TestCase
	{		
		public function CursorStackTest() 
		{
		}
		
		private var _stack:CursorStack;
		private var _cursor:Cursor;
		private var _cursor0:Cursor;
		private var _cursor1:Cursor;
		private var _cursor2:Cursor;
		private var _cursor3:Cursor;
		
		override protected function setUp():void
		{
			_cursor = new Cursor();
			_cursor0 = new Cursor();
			_cursor1 = new Cursor();
			_cursor2 = new Cursor();
			_cursor3 = new Cursor();
			_stack = new CursorStack();
			_stack.onChange = onChange;
			_log = [];
		}
		
		public function test_oneElementAdditionAndRemoving():void
		{
			var switcher:Switcher = new Switcher(_stack).setCursor(_cursor);
			
			assertEquals(null, _stack.cursor);
			switcher.enabled = true;
			assertEquals(_cursor, _stack.cursor);
			
			switcher.enabled = false;
			assertEquals(null, _stack.cursor);
		}
		
		public function test_valueAreEqualLastAddedValue():void
		{
			var switcher0:Switcher = new Switcher(_stack).setCursor(_cursor0);
			var switcher1:Switcher = new Switcher(_stack).setCursor(_cursor1);
			var switcher2:Switcher = new Switcher(_stack).setCursor(_cursor2);
			
			switcher0.enabled = true;
			switcher1.enabled = true;
			assertCursors("#1", _cursor1, [ _cursor0, _cursor1 ]);
			
			switcher1.enabled = false;
			assertCursors("#2", _cursor0, [ _cursor0 ]);
			
			switcher0.enabled = false;
			assertCursors("#3", null, []);
			
			switcher0.enabled = true;
			switcher1.enabled = true;
			assertCursors("#4", _cursor1, [ _cursor0, _cursor1 ]);
			
			switcher0.enabled = false;
			assertCursors("#5", _cursor1, [ _cursor1 ]);
			
			switcher1.enabled = false;
			assertCursors("#6", null, []);
			
			switcher0.enabled = true;
			switcher1.enabled = true;
			switcher2.enabled = true;
			assertCursors("#7", _cursor2, [ _cursor0, _cursor1, _cursor2 ]);
			
			switcher1.enabled = false;
			assertCursors("#8", _cursor2, [ _cursor0, _cursor2 ]);
			
			switcher1.enabled = true;
			assertCursors("#9", _cursor1, [ _cursor0, _cursor2, _cursor1 ]);
			
			switcher1.enabled = false;
			assertCursors("#10", _cursor2, [ _cursor0, _cursor2 ]);
			
			switcher0.enabled = false;
			assertCursors("#11", _cursor2, [ _cursor2 ]);
			
			switcher2.enabled = false;
			assertCursors("#12", null, []);
		}
		
		public function test_priorityIsTakedToAccount():void
		{
			var switcher0:Switcher = new Switcher(_stack, 0)
				.setCursor(_cursor0);
			var switcher1:Switcher = new Switcher(_stack, 1)
				.setCursor(_cursor1);
			var switcher2:Switcher = new Switcher(_stack, 2)
				.setCursor(_cursor2);
			
			switcher1.enabled = true;
			switcher0.enabled = true;
			assertCursors("#1", _cursor1, [ _cursor0, _cursor1 ]);
			
			switcher1.enabled = false;
			assertCursors("#2", _cursor0, [ _cursor0 ]);
			
			switcher0.enabled = false;
			assertCursors("#3", null, []);
			
			switcher2.enabled = true;
			switcher1.enabled = true;
			switcher0.enabled = true;
			assertCursors("#4", _cursor2, [_cursor0, _cursor1, _cursor2]);
			
			switcher1.enabled = false;
			assertCursors("#5", _cursor2, [ _cursor0, _cursor2 ]);
			
			switcher1.enabled = true;
			assertCursors("#6", _cursor2, [ _cursor0, _cursor1, _cursor2 ]);
			
			switcher0.enabled = false;
			assertCursors("#7", _cursor2, [ _cursor1, _cursor2 ]);
			
			switcher0.enabled = true;
			assertCursors("#8", _cursor2, [ _cursor0, _cursor1, _cursor2 ]);
			
			switcher2.enabled = false;
			assertCursors("#9", _cursor1, [ _cursor0, _cursor1 ]);
			
			switcher2.enabled = true;
			assertCursors("#10", _cursor2, [ _cursor0, _cursor1, _cursor2 ]);
			
			switcher0.enabled = false;
			assertCursors("#11", _cursor2, [ _cursor1, _cursor2 ]);
			
			switcher0.enabled = true;
			assertCursors("#12", _cursor2, [ _cursor0, _cursor1, _cursor2 ]);
		}
		
		public function test_repeatRemovingIsNothingChange():void
		{
			var switcher0:Switcher = new Switcher(_stack, 0)
				.setCursor(_cursor0);
			
			switcher0.enabled = false;
			assertCursors("#1", null, []);
			
			switcher0.enabled = true;
			assertCursors("#2", _cursor0, [ _cursor0 ]);
			
			switcher0.enabled = true;
			assertCursors("#3", _cursor0, [ _cursor0 ]);
			
			switcher0.enabled = false;
			assertCursors("#4", null, [ ]);
			
			switcher0.enabled = false;
			assertCursors("#5", null, [ ]);
			
			var switcher1:Switcher = new Switcher(_stack, 1).setCursor(_cursor1);
			var switcher2:Switcher = new Switcher(_stack, 2).setCursor(_cursor2);
			
			switcher1.enabled = true;
			switcher2.enabled = true;
			assertCursors("#6", _cursor2, [ _cursor1, _cursor2 ]);
			
			switcher1.enabled = false;
			assertCursors("#7", _cursor2, [ _cursor2 ]);
			switcher1.enabled = false;
			assertCursors("#8", _cursor2, [ _cursor2 ]);
		}
		
		public function
			repeatAdditionIsMoveElementToTopIfPrioritiesAreEqual():void
		{
			var switcher0:Switcher = new Switcher(_stack).setCursor(_cursor0);
			var switcher1:Switcher = new Switcher(_stack).setCursor(_cursor1);
			var switcher2:Switcher = new Switcher(_stack).setCursor(_cursor2);
			var switcher3:Switcher = new Switcher(_stack).setCursor(_cursor3);
			
			switcher0.enabled = true;
			switcher1.enabled = true;
			switcher2.enabled = true;
			switcher3.enabled = true;
			assertCursors(
				"#1", _cursor3, [ _cursor0, _cursor1, _cursor2, _cursor3 ]);
			
			switcher1.enabled = true;
			assertCursors(
				"#2", _cursor1, [ _cursor0, _cursor2, _cursor3, _cursor1 ]);
			
			switcher0.enabled = true;
			assertCursors(
				"#3", _cursor0, [ _cursor2, _cursor3, _cursor1, _cursor0 ]);
		}
		
		public function
			test_repeatAdditionIsMoveElementToTopIfPriorityAllowIt():void
		{
			var switcher0:Switcher = new Switcher(_stack, 1)
				.setCursor(_cursor0);
			var switcher1:Switcher = new Switcher(_stack, 1)
				.setCursor(_cursor1);
			var switcher2:Switcher = new Switcher(_stack, 2)
				.setCursor(_cursor2);
			var switcher3:Switcher = new Switcher(_stack, 2)
				.setCursor(_cursor3);
			
			switcher0.enabled = true;
			switcher1.enabled = true;
			switcher2.enabled = true;
			switcher3.enabled = true;
			assertCursors(
				"#1", _cursor3, [ _cursor0, _cursor1, _cursor2, _cursor3 ]);
			
			switcher1.enabled = true;
			assertCursors(
				"#2", _cursor3, [ _cursor0, _cursor1, _cursor2, _cursor3 ]);
			
			switcher0.enabled = true;
			assertCursors(
				"#3", _cursor3, [ _cursor1, _cursor0, _cursor2, _cursor3 ]);
			
			switcher3.enabled = true;
			assertCursors(
				"#4", _cursor3, [ _cursor1, _cursor0, _cursor2, _cursor3 ]);
			
			switcher2.enabled = true;
			assertCursors(
				"#5", _cursor2, [ _cursor1, _cursor0, _cursor3, _cursor2 ]);
		}
		
		public function test_valueOfTopNodeChangingIsChangeValueOfStack():void
		{
			var switcher:Switcher = new Switcher(_stack).setCursor(_cursor);
			switcher.enabled = true;
			assertEquals(_cursor, _stack.cursor);
			
			switcher.setCursor(_cursor3);
			assertEquals(_cursor3, _stack.cursor);
			
			switcher.setCursor(null);
			assertEquals(null, _stack.cursor);
			
			var switcher2:Switcher = new Switcher(_stack).setCursor(_cursor2);
			switcher2.enabled = true;
			assertEquals(_cursor2, _stack.cursor);
			
			switcher.setCursor(_cursor);
			switcher2.enabled = false;
			assertEquals(_cursor, _stack.cursor);
		}
		
		public function test_callbackCalledOnlyIfValueChanged():void
		{
			var switcher0:Switcher = new Switcher(_stack).setCursor(_cursor0);
			var switcher01:Switcher = new Switcher(_stack).setCursor(_cursor0);
			var switcher2:Switcher = new Switcher(_stack).setCursor(_cursor2);
			
			_log = [];
			assertEqualsArrays([], _log);
			switcher0.enabled = true;
			assertEqualsArrays([_cursor0], _log);
			assertEquals(_cursor0, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher01.enabled = true;
			assertEqualsArrays([], _log);
			assertEquals(_cursor0, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher2.enabled = true;
			assertEqualsArrays([_cursor2], _log);
			assertEquals(_cursor2, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher2.enabled = false;
			assertEqualsArrays([_cursor0], _log);
			assertEquals(_cursor0, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher01.enabled = false;
			assertEqualsArrays([], _log);
			assertEquals(_cursor0, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher0.enabled = false;
			assertEqualsArrays([null], _log);
			assertEquals(null, _stack.cursor);
			assertSwitcherCallbacksExistent();
		}
		
		private var _log:Array;
		
		private function onChange():void
		{
			_log.push(_stack.cursor);
		}
		
		public function test_changeDispatchedOnNodeValueChangedToo():void
		{
			var switcher0:Switcher = new Switcher(_stack).setCursor(_cursor0);
			var switcher1:Switcher = new Switcher(_stack).setCursor(_cursor1);
			
			_log = [];
			switcher0.enabled = true;
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher0.setCursor(_cursor1);
			assertEqualsArrays([_cursor1], _log);
			assertEquals(_cursor1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher0.setCursor(_cursor1);
			assertEqualsArrays([], _log);
			assertEquals(_cursor1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher1.enabled = true;
			assertEqualsArrays([], _log);
			assertEquals(_cursor1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			var newValue1:Cursor = new Cursor();
			switcher1.setCursor(newValue1);
			assertEqualsArrays([newValue1], _log);
			assertEquals(newValue1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher0.enabled = false;
			assertEqualsArrays([], _log);
			assertEquals(newValue1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			var value0NotInfluence:Cursor = new Cursor();
			switcher0.setCursor(value0NotInfluence);
			assertEqualsArrays([], _log);
			assertEquals(newValue1, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher1.enabled = false;
			assertEqualsArrays([null], _log);
			assertEquals(null, _stack.cursor);
			assertSwitcherCallbacksExistent();
			
			_log = [];
			switcher1.setCursor(value0NotInfluence);
			assertEqualsArrays([], _log);
			assertEquals(null, _stack.cursor);
			assertSwitcherCallbacksExistent();
		}
		
		private function assertSwitcherCallbacksExistent():void
		{
			var switchers:Array = _stack.switchers;
			var length:int = switchers.length;
			for (var i:int = 0; i < length - 1; i++)
			{
				var switcher:Switcher = switchers[i];
				assertNull(switcher.onChange);
			}
			if (switchers.length > 0)
			{
				assertNotNull(switchers[switchers.length - 1]);
			}
		}
		
		private function assertCursors(
			text:String, expectedCursor:Cursor, explectedCursors:Array):void
		{
			assertEquals(text, expectedCursor, _stack.cursor);
			if (explectedCursors.length == 0)
			{
				assertNull(text, _stack.cursor);
			}
			var actualCursors:Array = [];
			for each (var switcher:Switcher in _stack.switchers)
			{
				actualCursors.push(switcher.cursor);
			}
			assertEqualsArrays(text, explectedCursors, actualCursors);
		}
	}
}